/** general keyboard format definition function.  If the format **/
/** is 0 then the keyboard is set to the normal buffered        **/
/** state where the usual C input routines will operate.  If    **/
/** the format is 1 then the keyboard is put in raw format and  **/
/** the keyboard is interrupt driven through the readcbuf       **/
/** routine.  This routine will only change the device keyboard **/
/** driver it the driver is one of the two generic keyboard     **/
/** drivers                                                     **/

#include "gph_str.h"
#include "gph_ansi.h"

static ByTe_1 rcsid[] = "$Id: kybd_fmt.c,v 1.1 1999/11/21 07:46:15 chris.gurgiolo.b2r Stab chrisg $";

char kybd_fmt (char mode, char cfont, short size, short color)
{
   extern struct memory minfo;
   extern struct config    parm;
   register struct graph_kbd *kb;
   register struct dev_graph *dg;

   long status;

   kb = parm.gkbd;

   if ((mode & GTLN_BUFFER) == 1)
   {
      kb->k_font = cfont;
      kb->k_size = size;
      kb->k_color = color;
   }

   kb->k_mode = mode;
   dg = (struct dev_graph *)minfo.mdrv;
   status = dg->_kybd ();

   return (1);
}
